pidgin: whiteboard.h File Reference

pidgin 2.14.4

Loading...
Searching...
No Matches
Data Structures | Typedefs
whiteboard.h File Reference

The PurpleWhiteboard core object. More...

`#include "account.h"`

Go to the source code of this file.

## Data Structures
struct | _PurpleWhiteboard
| A PurpleWhiteboard. More...
struct | _PurpleWhiteboardUiOps
| The PurpleWhiteboard UI Operations. More...
struct | _PurpleWhiteboardPrplOps
| PurpleWhiteboard PRPL Operations. More...

## Typedefs
typedef struct _PurpleWhiteboardPrplOps | PurpleWhiteboardPrplOps
| Whiteboard PRPL Operations.
typedef struct _PurpleWhiteboard | PurpleWhiteboard
| A PurpleWhiteboard.
typedef struct _PurpleWhiteboardUiOps | PurpleWhiteboardUiOps
| The PurpleWhiteboard UI Operations.

## Functions
PurpleWhiteboard API <br>
void | purple_whiteboard_set_ui_ops (PurpleWhiteboardUiOps *ops)
| Sets the UI operations.
void | purple_whiteboard_set_prpl_ops (PurpleWhiteboard *wb, PurpleWhiteboardPrplOps *ops)
| Sets the prpl operations for a whiteboard.
PurpleWhiteboard * | purple_whiteboard_create (PurpleAccount *account, const char *who, int state)
| Creates a whiteboard.
void | purple_whiteboard_destroy (PurpleWhiteboard *wb)
| Destroys a whiteboard.
void | purple_whiteboard_start (PurpleWhiteboard *wb)
| Starts a whiteboard.
PurpleWhiteboard * | purple_whiteboard_get_session (const PurpleAccount *account, const char *who)
| Finds a whiteboard from an account and user.
void | purple_whiteboard_draw_list_destroy (GList *draw_list)
| Destorys a drawing list for a whiteboard.
gboolean | purple_whiteboard_get_dimensions (const PurpleWhiteboard *wb, int *width, int *height)
| Gets the dimension of a whiteboard.
void | purple_whiteboard_set_dimensions (PurpleWhiteboard *wb, int width, int height)
| Sets the dimensions for a whiteboard.
void | purple_whiteboard_draw_point (PurpleWhiteboard *wb, int x, int y, int color, int size)
| Draws a point on a whiteboard.
void | purple_whiteboard_send_draw_list (PurpleWhiteboard *wb, GList *list)
| Send a list of points to draw to the buddy.
void | purple_whiteboard_draw_line (PurpleWhiteboard *wb, int x1, int y1, int x2, int y2, int color, int size)
| Draws a line on a whiteboard.
void | purple_whiteboard_clear (PurpleWhiteboard *wb)
| Clears a whiteboard.
void | purple_whiteboard_send_clear (PurpleWhiteboard *wb)
| Sends a request to the buddy to clear the whiteboard.
void | purple_whiteboard_send_brush (PurpleWhiteboard *wb, int size, int color)
| Sends a request to change the size and color of the brush.
gboolean | purple_whiteboard_get_brush (const PurpleWhiteboard *wb, int *size, int *color)
| Gets the size and color of the brush.
void | purple_whiteboard_set_brush (PurpleWhiteboard *wb, int size, int color)
| Sets the size and color of the brush.

## Detailed Description

The PurpleWhiteboard core object.

Definition in file whiteboard.h.

## Typedef Documentation

## ◆ PurpleWhiteboardPrplOps

typedef struct _PurpleWhiteboardPrplOps PurpleWhiteboardPrplOps

Whiteboard PRPL Operations.

Definition at line 32 of file whiteboard.h.

## Function Documentation

## ◆ purple_whiteboard_clear()

void purple_whiteboard_clear | ( | PurpleWhiteboard * | wb | ) |

Clears a whiteboard.

Parameters

  wb | The whiteboard.

## ◆ purple_whiteboard_create()

PurpleWhiteboard * purple_whiteboard_create | ( | PurpleAccount * | account,
|  | const char * | who,
|  | int | state
| ) |  |

Creates a whiteboard.

Parameters

  account | The account.
  who | Who you're drawing with.
  state | The state.

Returns
  The new whiteboard

## ◆ purple_whiteboard_destroy()

void purple_whiteboard_destroy | ( | PurpleWhiteboard * | wb | ) |

Destroys a whiteboard.

Parameters

  wb | The whiteboard.

## ◆ purple_whiteboard_draw_line()

void purple_whiteboard_draw_line | ( | PurpleWhiteboard * | wb,
|  | int | x1,
|  | int | y1,
|  | int | x2,
|  | int | y2,
|  | int | color,
|  | int | size
| ) |  |

Draws a line on a whiteboard.

Parameters

  wb | The whiteboard.
  x1 | The top-left x coordinate.
  y1 | The top-left y coordinate.
  x2 | The bottom-right x coordinate.
  y2 | The bottom-right y coordinate.
  color | The color to use.
  size | The brush size.

## ◆ purple_whiteboard_draw_list_destroy()

void purple_whiteboard_draw_list_destroy | ( | GList * | draw_list | ) |

Destorys a drawing list for a whiteboard.

Parameters

  draw_list | The drawing list.

## ◆ purple_whiteboard_draw_point()

void purple_whiteboard_draw_point | ( | PurpleWhiteboard * | wb,
|  | int | x,
|  | int | y,
|  | int | color,
|  | int | size
| ) |  |

Draws a point on a whiteboard.

Parameters

  wb | The whiteboard.
  x | The x coordinate.
  y | The y coordinate.
  color | The color to use.
  size | The brush size.

## ◆ purple_whiteboard_get_brush()

gboolean purple_whiteboard_get_brush | ( | const PurpleWhiteboard * | wb,
|  | int * | size,
|  | int * | color
| ) |  |

Gets the size and color of the brush.

Parameters

  wb | The whiteboard
  size | The size of the brush
  color | The color of the brush

Returns
  TRUE if the size and color were set.

## ◆ purple_whiteboard_get_dimensions()

gboolean purple_whiteboard_get_dimensions | ( | const PurpleWhiteboard * | wb,
|  | int * | width,
|  | int * | height
| ) |  |

Gets the dimension of a whiteboard.

Parameters

  wb | The whiteboard.
  width | The width to be set.
  height | The height to be set.

Returns
  TRUE if the values of width and height were set.

## ◆ purple_whiteboard_get_session()

PurpleWhiteboard * purple_whiteboard_get_session | ( | const PurpleAccount * | account,
|  | const char * | who
| ) |  |

Finds a whiteboard from an account and user.

Parameters

  account | The account.
  who | The user.

Returns
  The whiteboard if found, otherwise `NULL`.

## ◆ purple_whiteboard_send_brush()

void purple_whiteboard_send_brush | ( | PurpleWhiteboard * | wb,
|  | int | size,
|  | int | color
| ) |  |

Sends a request to change the size and color of the brush.

Parameters

  wb | The whiteboard
  size | The size of the brush
  color | The color of the brush

## ◆ purple_whiteboard_send_clear()

void purple_whiteboard_send_clear | ( | PurpleWhiteboard * | wb | ) |

Sends a request to the buddy to clear the whiteboard.

Parameters

  wb | The whiteboard

## ◆ purple_whiteboard_send_draw_list()

void purple_whiteboard_send_draw_list | ( | PurpleWhiteboard * | wb,
|  | GList * | list
| ) |  |

Send a list of points to draw to the buddy.

Parameters

  wb | The whiteboard
  list | A GList of points

## ◆ purple_whiteboard_set_brush()

void purple_whiteboard_set_brush | ( | PurpleWhiteboard * | wb,
|  | int | size,
|  | int | color
| ) |  |

Sets the size and color of the brush.

Parameters

  wb | The whiteboard
  size | The size of the brush
  color | The color of the brush

## ◆ purple_whiteboard_set_dimensions()

void purple_whiteboard_set_dimensions | ( | PurpleWhiteboard * | wb,
|  | int | width,
|  | int | height
| ) |  |

Sets the dimensions for a whiteboard.

Parameters

  wb | The whiteboard.
  width | The width.
  height | The height.

## ◆ purple_whiteboard_set_prpl_ops()

void purple_whiteboard_set_prpl_ops | ( | PurpleWhiteboard * | wb,
|  | PurpleWhiteboardPrplOps * | ops
| ) |  |

Sets the prpl operations for a whiteboard.

Parameters

  wb | The whiteboard for which to set the prpl operations
  ops | The prpl operations to set

## ◆ purple_whiteboard_set_ui_ops()

void purple_whiteboard_set_ui_ops | ( | PurpleWhiteboardUiOps * | ops | ) |

Sets the UI operations.

Parameters

  ops | The UI operations to set

## ◆ purple_whiteboard_start()

void purple_whiteboard_start | ( | PurpleWhiteboard * | wb | ) |

Starts a whiteboard.

Parameters

  wb | The whiteboard.